/****************************************************************************
** Form implementation generated from reading ui file 'uiorbit.ui'
**
** Created: Sun Jul 16 13:40:59 2006
**      by: The User Interface Compiler ($Id: qt/main.cpp   3.3.5   edited Aug 31 12:13 $)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include <qpushbutton.h>
#include <qstringlist.h>
#include <qimage.h>
#include <qpixmap.h>
#include <qpainter.h>
#include <qlabel.h>
#include <qfile.h>
#include <qpoint.h>
#include <qtimer.h>

#include "orbit.h"

Orbit::Orbit( QWidget* parent, const char* name, bool modal, WFlags fl )
    : uiOrbit ( parent, name, modal, fl )
{
  m_pTimer = NULL;
  // signals and slots connections
  connect( m_pButtonDoit, SIGNAL( clicked() ), this, SLOT( slotDoit    ( ) ) );
  connect( m_pButtonAnim, SIGNAL( clicked() ), this, SLOT( slotAnimate ( ) ) );
}

Orbit::~Orbit ( )
{
  // no need to delete child widgets, Qt does it all for us
  if ( m_pTimer )
    delete m_pTimer;
  m_pTimer = NULL;
}

void Orbit::slotDoit ( )
{
  m_background = QPixmap ( "05_orbit.jpg" );
  QPainter thePainter ( &m_background );
  QPen thePen ( QColor ( 255, 0, 0 ), 3 );
  thePainter.setPen ( thePen );

  system ( "script.awk > script.out" );

  // file format  : x [space] y
  QFile theFile ( "script.out" );
  if ( theFile.open ( IO_ReadOnly ) ) {
    QTextStream stream( &theFile );
    QStringList listXY;
    QString line;
    int x, y, i = 1;
    float  z;
    while ( !stream.atEnd() ) {
      line = stream.readLine(); // line of text excluding '\n'
      listXY = QStringList::split ( " ", line );
      if ( listXY.size ( ) != 3 )
	continue;
      x = listXY[0].toInt   ( );
      y = listXY[1].toInt   ( );
      z = listXY[2].toFloat ( );
      QPoint point ( x, y );
      m_points.append ( point );
      m_Z.append ( z );

      printf( "%3d: %d - %d - %f\n", i++, x, y, z );
      //     thePainter.drawPoint ( x, y );
      thePainter.drawRect ( x, y, 2, 2 );
    }
    theFile.close();
  }

  // FInally we set the image ...
  m_pPreview->setPixmap ( m_background );
}

void Orbit::slotAnimate ()
{
  if ( m_pTimer )
    delete m_pTimer;
  m_iCurrentPosition = 0;
  m_pTimer = new QTimer( this );
  connect( m_pTimer, SIGNAL ( timeout ( ) ), this, SLOT ( slotDrawShuttle ( ) ) );
  m_pTimer->start ( 100, FALSE ); // 2 seconds single-shot timer  
}

void Orbit::slotDrawShuttle ( )
{
  QImage shuttle  ( "shuttle.gif" );
  QPixmap buffer  ( m_background );
  
  float  fZoom = m_Z     [m_iCurrentPosition];
  QPoint point = m_points[m_iCurrentPosition++];
  int w, h;
  w = (int)(fZoom * shuttle.width  ( ) );
  h = (int)(fZoom * shuttle.height ( ) );

  shuttle = shuttle.smoothScale ( w, h );

  //  printf ( "[%d] = zoom<%f> - w=<%d> h<%d>\n", m_iCurrentPosition, fZoom, w, h );

  if ( m_iCurrentPosition >= 300 ) {
    if ( m_pTimer )
      delete m_pTimer;
    m_pTimer = NULL;
    m_iCurrentPosition = 0;
    return;
  }

  QPainter thePainter   ( &buffer );
  thePainter.drawImage  ( point.x(), point.y(), shuttle, 0, 0, w, h );
  m_pPreview->setPixmap ( buffer );
}
